diff -ur angband-3.0.1.orig/src/main-x11.c angband-3.0.1.bigtile/src/main-x11.c
--- angband-3.0.1.orig/src/main-x11.c	Sun Jun 30 19:15:09 2002
+++ angband-3.0.1.bigtile/src/main-x11.c	Sun Jul 14 06:48:41 2002
@@ -319,6 +319,7 @@
 	cptr name;
 
 	s16b wid;
+	s16b twid;
 	s16b hgt;
 	s16b asc;
 
@@ -1232,6 +1233,11 @@
 	ifnt->wid = cs->width;
 #endif
 
+	if (use_bigtile)
+		ifnt->twid = 2 * cs->width;
+	else
+		ifnt->twid = cs->width;
+
 	/* Success */
 	return (0);
 }
@@ -1453,7 +1459,8 @@
 
 #ifdef USE_GRAPHICS
 
-	XImage *tiles;
+	XImage *tiles[64];
+        int tiles_col[64];
 
 	/* Tempory storage for overlaying tiles. */
 	XImage *TmpImage;
@@ -1921,9 +1928,7 @@
 
 
 /*
- * Draw the cursor as an inverted rectangle.
- *
- * Consider a rectangular outline like "main-mac.c".  XXX XXX
+ * Draw the cursor as a rectangular outline
  */
 static errr Term_curs_x11(int x, int y)
 {
@@ -1938,6 +1943,21 @@
 
 
 /*
+ * Draw the double width cursor as a rectangular outline
+ */
+static errr Term_bigcurs_x11(int x, int y)
+{
+	XDrawRectangle(Metadpy->dpy, Infowin->win, xor->gc,
+			 x * Infofnt->wid + Infowin->ox,
+			 y * Infofnt->hgt + Infowin->oy,
+			 Infofnt->twid - 1, Infofnt->hgt - 1);
+
+	/* Success */
+	return (0);
+}
+
+
+/*
  * Erase some characters.
  */
 static errr Term_wipe_x11(int x, int y, int n)
@@ -1977,6 +1997,7 @@
 static errr Term_pict_x11(int x, int y, int n, const byte *ap, const char *cp, const byte *tap, const char *tcp)
 {
 	int i, x1, y1;
+        int group1, group2;
 
 	byte a;
 	char c;
@@ -2003,43 +2024,123 @@
 		a = *ap++;
 		c = *cp++;
 
-		/* For extra speed - cache these values */
-		x1 = (c&0x7F) * td->fnt->wid;
-		y1 = (a&0x7F) * td->fnt->hgt;
-
-		ta = *tap++;
-		tc = *tcp++;
-
-		/* For extra speed - cache these values */
-		x2 = (tc&0x7F) * td->fnt->wid;
-		y2 = (ta&0x7F) * td->fnt->hgt;
+                /* Second byte of Bigtile (dummy) */
+		if (a == 255 && c == -1) continue;
+
+                ta = *tap++;
+                tc = *tcp++;
+
+                if (arg_graphics == GRAPHICS_DAVID_GERVAIS)
+                {
+                        group1 = (a&0x7F);
+                        group2 = (ta&0x7F);
+
+                        /* Dummy or illegal group */
+                        if (td->tiles[group1])
+                        {
+                                /* For extra speed - cache these values */
+                                x1 = ((c&0x7F) % td->tiles_col[group1]) * td->fnt->twid;
+                                y1 = ((c&0x7F) / td->tiles_col[group1]) * td->fnt->hgt;
+                        }
+
+                        /* For extra speed - cache these values */
+                        if (!td->tiles[group2])
+                        {
+                                group2 = group1;
+                                x2 = x1;
+                                y2 = y1;
+                        }
+                        else
+                        {
+                                group2 = (ta&0x7F);
+                                x2 = ((tc&0x7F) % td->tiles_col[group2]) * td->fnt->twid;
+                                y2 = ((tc&0x7F) / td->tiles_col[group2]) * td->fnt->hgt;
+                        }
+                }
+                else
+                {
+                        /* For extra speed - cache these values */
+                        x1 = (c&0x7F) * td->fnt->twid;
+                        y1 = (a&0x7F) * td->fnt->hgt;
+                        group1 = 0;
+
+                        /* For extra speed - cache these values */
+                        x2 = (tc&0x7F) * td->fnt->twid;
+                        y2 = (ta&0x7F) * td->fnt->hgt;
+                        group2 = 0;
+                }
+
+                /* Blank tile */
+                if (!td->tiles[group1])
+                {
+                        /* Erase rectangle */
+                        XFillRectangle(Metadpy->dpy, Infowin->win, clr[0]->gc,
+                                          x, y,
+                                          td->fnt->twid, td->fnt->hgt);
+                }
 
 		/* Optimise the common case */
-		if ((x1 == x2) && (y1 == y2))
+		else if (((x1 == x2) && (y1 == y2) && (group1 == group2)) ||
+		    !(((byte)ta & 0x80) && ((byte)tc & 0x80)))
 		{
-			/* Draw object / terrain */
-			XPutImage(Metadpy->dpy, td->win->win,
-		  	        clr[0]->gc,
-		  	        td->tiles,
-		  	        x1, y1,
-		  	        x, y,
-		  	        td->fnt->wid, td->fnt->hgt);
+                        if (arg_graphics != GRAPHICS_DAVID_GERVAIS)
+                        {
+                                /* Draw object / terrain */
+                                XPutImage(Metadpy->dpy, td->win->win,
+                                          clr[0]->gc,
+                                          td->tiles[group1],
+                                          x1, y1,
+                                          x, y,
+                                          td->fnt->twid, td->fnt->hgt);
+                        }
+                        else
+                        {
+                                /* Mega Hack^2 - assume the top left corner is "blank" */
+                                blank = XGetPixel(td->tiles[3], 0, 0);
+
+                                for (k = 0; k < td->fnt->twid; k++)
+                                {
+                                        for (l = 0; l < td->fnt->hgt; l++)
+                                        {
+                                                /* If mask set... */
+                                                if ((pixel = XGetPixel(td->tiles[group1], x1 + k, y1 + l)) == blank)
+                                                        pixel = 0L;
+
+                                                /* Store into the temp storage. */
+                                                XPutPixel(td->TmpImage, k, l, pixel);
+                                        }
+                                }
+
+
+                                /* Draw to screen */
+
+                                XPutImage(Metadpy->dpy, td->win->win,
+                                          clr[0]->gc,
+                                          td->TmpImage,
+                                          0, 0, x, y,
+                                          td->fnt->twid, td->fnt->hgt);
+                        }
 		}
 		else
 		{
 
-			/* Mega Hack^2 - assume the top left corner is "black" */
-			blank = XGetPixel(td->tiles, 0, td->fnt->hgt * 6);
+			/* Mega Hack^2 - assume the top left corner is "blank" */
+                        if (arg_graphics == GRAPHICS_DAVID_GERVAIS)
+                                blank = XGetPixel(td->tiles[3], 0, 0);
+                        else
+                                blank = XGetPixel(td->tiles[group1], 0, td->fnt->hgt * 6);
 
-			for (k = 0; k < td->fnt->wid; k++)
+			for (k = 0; k < td->fnt->twid; k++)
 			{
 				for (l = 0; l < td->fnt->hgt; l++)
 				{
 					/* If mask set... */
-					if ((pixel = XGetPixel(td->tiles, x1 + k, y1 + l)) == blank)
+					if ((pixel = XGetPixel(td->tiles[group1], x1 + k, y1 + l)) == blank)
 					{
 						/* Output from the terrain */
-						pixel = XGetPixel(td->tiles, x2 + k, y2 + l);
+						pixel = XGetPixel(td->tiles[group2], x2 + k, y2 + l);
+                                                if (pixel == blank)
+                                                        pixel = 0L;
 					}
 
 					/* Store into the temp storage. */
@@ -2054,7 +2155,7 @@
 		    	      clr[0]->gc,
 		     	     td->TmpImage,
 		     	     0, 0, x, y,
-		     	     td->fnt->wid, td->fnt->hgt);
+		     	     td->fnt->twid, td->fnt->hgt);
 		}
 
 		x += td->fnt->wid;
@@ -2252,6 +2353,7 @@
 	/* Hooks */
 	t->xtra_hook = Term_xtra_x11;
 	t->curs_hook = Term_curs_x11;
+	t->bigcurs_hook = Term_bigcurs_x11;
 	t->wipe_hook = Term_wipe_x11;
 	t->text_hook = Term_text_x11;
 
@@ -2269,10 +2371,56 @@
 const char help_x11[] = "Basic X11, subopts -d<display> -n<windows>"
 #ifdef USE_GRAPHICS
                         " -s(moothRescale)"
+                        "\n           -b(Bigtile) -o(original) -a(AdamBolt) -g(David Gervais)"
 #endif
                         ;
 
 
+static const char *original_tile_files[] = {"8x8.bmp", NULL};
+static const char *adam_bolt_tile_files[] = {"16x16.bmp", NULL};
+static const char *david_gervais_tile_files[] = {
+        "", 
+        "", 
+        "", 
+        "dg_armor32.bmp", 
+        "dg_effects32.bmp", 
+        "dg_food32.bmp", 
+        "dg_classm32.bmp", 
+        "dg_humans32.bmp", 
+        "dg_jewls32.bmp", 
+        "dg_magic32.bmp", 
+        "dg_misc32.bmp", 
+        "dg_potions32.bmp", 
+        "dg_wands32.bmp", 
+        "dg_weapons32.bmp", 
+        "dg_people32.bmp", 
+        "dg_dragon32.bmp", 
+        "dg_monster132.bmp", 
+        "dg_monster232.bmp", 
+        "dg_monster332.bmp", 
+        "dg_monster432.bmp", 
+        "dg_monster532.bmp", 
+        "dg_monster632.bmp", 
+        "dg_monster732.bmp", 
+        "dg_undead32.bmp", 
+        "dg_uniques32.bmp", 
+        "dg_dungeon32.bmp", 
+        "dg_grounds32.bmp", 
+        "dg_extra132.bmp", 
+        "dg_town032.bmp", 
+        "dg_town132.bmp", 
+        "dg_town232.bmp", 
+        "dg_town332.bmp", 
+        "dg_town432.bmp", 
+        "dg_town532.bmp", 
+        "dg_town632.bmp", 
+        "dg_town732.bmp", 
+        "dg_town832.bmp", 
+        "dg_town932.bmp", 
+        NULL
+};
+
+
 /*
  * Initialization function for an "X11" module to Angband
  */
@@ -2286,6 +2434,7 @@
 
 #ifdef USE_GRAPHICS
 
+	const char **tile_files;
 	char filename[1024];
 
 	int pict_wid = 0;
@@ -2311,6 +2460,32 @@
 			smoothRescaling = FALSE;
 			continue;
 		}
+
+		if (prefix(argv[i], "-o"))
+		{
+			arg_graphics = GRAPHICS_ORIGINAL;
+			continue;
+		}
+
+		if (prefix(argv[i], "-a"))
+		{
+			arg_graphics = GRAPHICS_ADAM_BOLT;
+			continue;
+		}
+
+		if (prefix(argv[i], "-g"))
+		{
+			smoothRescaling = FALSE;
+			arg_graphics = GRAPHICS_DAVID_GERVAIS;
+			continue;
+		}
+
+		if (prefix(argv[i], "-b"))
+		{
+			use_bigtile = TRUE;
+			continue;
+		}
+
 #endif /* USE_GRAPHICS */
 
 		if (prefix(argv[i], "-n"))
@@ -2391,39 +2566,62 @@
 #ifdef USE_GRAPHICS
 
 	/* Try graphics */
-	if (arg_graphics)
+	switch (arg_graphics)
 	{
+	case GRAPHICS_ADAM_BOLT:
+                /* Use tile graphics of Adam Bolt */
+                tile_files = adam_bolt_tile_files;
+
 		/* Try the "16x16.bmp" file */
-		path_build(filename, sizeof(filename), ANGBAND_DIR_XTRA, "graf/16x16.bmp");
+		path_build(filename, sizeof(filename), ANGBAND_DIR_XTRA, format("graf/%s", tile_files[0]));
 
 		/* Use the "16x16.bmp" file if it exists */
 		if (0 == fd_close(fd_open(filename, O_RDONLY)))
 		{
 			/* Use graphics */
 			use_graphics = TRUE;
-
 			use_transparency = TRUE;
 
 			pict_wid = pict_hgt = 16;
 
 			ANGBAND_GRAF = "new";
+
+			break;
 		}
-		else
-		{
-			/* Try the "8x8.bmp" file */
-			path_build(filename, sizeof(filename), ANGBAND_DIR_XTRA, "graf/8x8.bmp");
+		/* Fall through */
 
-			/* Use the "8x8.bmp" file if it exists */
-			if (0 == fd_close(fd_open(filename, O_RDONLY)))
-			{
-				/* Use graphics */
-				use_graphics = TRUE;
+	case GRAPHICS_ORIGINAL:
+                /* Use original tile graphics */
+                tile_files = original_tile_files;
 
-				pict_wid = pict_hgt = 8;
+		/* Try the "8x8.bmp" file */
+		path_build(filename, sizeof(filename), ANGBAND_DIR_XTRA, format("graf/%s", tile_files[0]));
 
-				ANGBAND_GRAF = "old";
-			}
+		/* Use the "8x8.bmp" file if it exists */
+		if (0 == fd_close(fd_open(filename, O_RDONLY)))
+		{
+			/* Use graphics */
+			use_graphics = TRUE;
+
+			pict_wid = pict_hgt = 8;
+
+			ANGBAND_GRAF = "old";
+			break;
 		}
+                break;
+
+	case GRAPHICS_DAVID_GERVAIS:
+                /* Use tile graphics of David Gervais */
+                tile_files = david_gervais_tile_files;
+
+                /* Use graphics */
+                use_graphics = TRUE;
+                use_transparency = TRUE;
+                
+                pict_wid = pict_hgt = 32;
+                
+                ANGBAND_GRAF = "david";
+                break;
 	}
 
 	/* Load graphics */
@@ -2433,29 +2631,82 @@
 
 		XImage *tiles_raw;
 
-		/* Load the graphical tiles */
-		tiles_raw = ReadBMP(dpy, filename);
-
-		/* Initialize the windows */
-		for (i = 0; i < num_term; i++)
-		{
-			term_data *td = &data[i];
-
-			term *t = &td->t;
-
-			/* Graphics hook */
-			t->pict_hook = Term_pict_x11;
-
-			/* Use graphics sometimes */
-			t->higher_pict = TRUE;
-
-			/* Resize tiles */
-			td->tiles =
-			ResizeImage(dpy, tiles_raw,
-			            pict_wid, pict_hgt,
-			            td->fnt->wid, td->fnt->hgt);
-		}
+                int group;
 
+                /* Initialize */
+                for (group = 0; group < 64; group++)
+                {
+                        for (i = 0; i < num_term; i++)
+                        {
+                                term_data *td = &data[i];
+                                td->tiles[group] = NULL;
+                        }
+                }
+
+                /* Load each group of tile set */
+                for (group = 0; tile_files[group]; group++)
+                {
+                        /* Dummy group */
+                        if (!tile_files[group][0]) continue;
+
+                        path_build(filename, sizeof(filename), ANGBAND_DIR_XTRA, format("graf/%s", tile_files[group]));
+
+                        /* Load the graphical tiles */
+                        tiles_raw = ReadBMP(dpy, filename);
+
+                        /* No such file */
+                        if (!tiles_raw) continue;
+
+                        /* Initialize the windows */
+                        for (i = 0; i < num_term; i++)
+                        {
+                                int j;
+                                bool same = FALSE;
+
+                                term_data *td = &data[i];
+                                term_data *o_td;
+                                
+                                term *t = &td->t;
+                                
+                                /* Graphics hook */
+                                t->pict_hook = Term_pict_x11;
+                                
+                                /* Use graphics sometimes */
+                                t->higher_pict = TRUE;
+                                
+                                /* Look for another term with same font size */
+                                for (j = 0; j < i; j++)
+                                {
+                                        o_td = &data[j];
+
+                                        if (td->fnt->twid == o_td->fnt->twid && td->fnt->hgt == o_td->fnt->hgt)
+                                        {
+                                                same = TRUE;
+                                                break;
+                                        }
+
+                                }
+
+                                if (!same)
+                                {
+                                        /* Resize tiles */
+                                        td->tiles[group] =
+                                                ResizeImage(dpy, tiles_raw,
+                                                            pict_wid, pict_hgt,
+                                                            td->fnt->twid, td->fnt->hgt);
+                                }
+                                else
+                                {
+                                        /* Use same graphics */
+                                        td->tiles[group] = o_td->tiles[group];
+                                }
+
+                                td->tiles_col[group] = td->tiles[group]->width / td->fnt->twid;
+                        }
+                        /* Free tiles_raw */
+                        FREE(tiles_raw);
+                }
+                        
 		/* Initialize the transparency masks */
 		for (i = 0; i < num_term; i++)
 		{
@@ -2470,18 +2721,16 @@
 			ii = 1;
 			jj = (depth - 1) >> 2;
 			while (jj >>= 1) ii <<= 1;
-			total = td->fnt->wid * td->fnt->hgt * ii;
+			total = td->fnt->twid * td->fnt->hgt * ii;
 
 
 			TmpData = (char *)malloc(total);
 
 			td->TmpImage = XCreateImage(dpy,visual,depth,
 				ZPixmap, 0, TmpData,
-				td->fnt->wid, td->fnt->hgt, 32, 0);
+				td->fnt->twid, td->fnt->hgt, 32, 0);
 
 		}
-
-		/* Free tiles_raw? XXX XXX */
 	}
 
 #endif /* USE_GRAPHICS */
Only in angband-3.0.1.bigtile/src: main-x11.o
